/**
 * returns the position of value and the number of comparisons it performed.
 *@param {*} array the array in which to search the element.
 *@param {Object} item the element to search.
 *
 */
 declare function linearSearch<T>(array: T[], item: T): {
    position: number;
    comparisons: number;
};
/**
 * this function will return position of value , if value found in the array.
 * If value not found in the list it returns message like value not  present in the list.
 *@param {*} array the array in which to search the element.
 *@param {Object} item the element to search.
 */
declare function binarySearch<T>(array: T[], item: T) : number|string ;
