/**
 * returns the position of value and the number of comparisons it performed.
 *@param {*} array the array in which to search the element.
 *@param {Object} item the element to search.
 *
 */
function linearSearch<T> (array: T[], item: T): {} {
    let position = -1;
    let comparisons = 0;
    let result = {};
    const length = array.length;
    for (let i = 0; i < length; i++) {
        comparisons++;
        if (array[i] === item) {
            result.position = i;
            result.comparisons = comparisons;
            return result;
        }
    }
    return result;
}
/**
 * this function will return position of value , if value found in the array.
 * If value not found in the list it returns message like value not  present in the list.
 *@param {*} array the array in which to search the element.
 *@param {Object} item the element to search.
 */
function binarySearch<T>(array: T[], item: T): void {
 const length = array.length;

for (let i = 0; i < length; i++) {
  let   first  = 0;
  let  last   = length - 1;
  let  value = (first + last) / 2;
  let middle = parseInt(value.toFixed(0));
  while (first <= last ) {
    if (array[middle] < item ) {
        first = middle + 1;
        }
    else if (array[middle] === item ) {
        console.log(item + "   found at position   :  " + ( ++ middle));
      }
    else {
        last = middle - 1;
        middle = (first + last) / 2;
         }
 }
  if (first > last) {
        console.log(item + " is not present in the list.");
          }
}
}
